
// TestMZDlg.cpp : t@C
//

#include "stdafx.h"
#include <math.h>
#include "TestMZ.h"
#include "TestMZDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestMZDlg _CAO




CTestMZDlg::CTestMZDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestMZDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestMZDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHK_3DNOW, m_chk3DNOW);
	DDX_Control(pDX, IDC_CHK_3DNOW_EXT, m_chk3DNOW_EXT);
	DDX_Control(pDX, IDC_CHK_AMD_V, m_chkAMD_V);
	DDX_Control(pDX, IDC_CHK_INTEL_VT, m_chkINTEL_VT);
	DDX_Control(pDX, IDC_CHK_MMX, m_chkMMX);
	DDX_Control(pDX, IDC_CHK_MMX_EXT, m_chkMMX_EXT);
	DDX_Control(pDX, IDC_CHK_SSE, m_chkSSE);
	DDX_Control(pDX, IDC_CHK_SSE2, m_chkSSE2);
	DDX_Control(pDX, IDC_CHK_SSE3, m_chkSSE3);
	DDX_Control(pDX, IDC_CHK_SSE4p1, m_chkSSE4p1);
	DDX_Control(pDX, IDC_CHK_SSE4p2, m_chkSSE4p2);
	DDX_Control(pDX, IDC_CHK_SSE4A, m_chkSSE4A);
	DDX_Control(pDX, IDC_CHK_X64, m_chkX64);
	DDX_Control(pDX, IDC_LAB_CPUID, m_labCPUID);
	DDX_Control(pDX, IDC_LAB_VERSION, m_labVersion);
	DDX_Control(pDX, IDC_LAB_WOW64, m_labWOW64);
	DDX_Control(pDX, IDC_LAB_WINDOWSVERSION, m_labWindowsVersion);
}

BEGIN_MESSAGE_MAP(CTestMZDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CTestMZDlg bZ[W nh

BOOL CTestMZDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	//
	//// CPUID
	//
	const	INT					nTest	= 2;
			CMGC1MZ::INFORMATION	cif;
			CMGC1MZ::IDENTITY		cid;
			DWORD				dwMeasurementTime	= 300;
			INT					nFrequency			= 0;
			INT					nR;


	SecureZeroMemory(&cif, sizeof(CMGC1MZ::INFORMATION));
	SecureZeroMemory(&cid, sizeof(CMGC1MZ::IDENTITY));

	if(nTest == 1)
	{
		TCHAR szFileName[MAX_PATH] = _T("MMZ");

		m_mz.GetTemporaryFileName(FALSE, szFileName, MAX_PATH);
		nR = m_mz.GetIdentity(NULL, 50, szFileName, CMGC1MZ::codeUTF16BE);
	}
	else if (nTest == 2)
	{
		cid.nSize = sizeof(CMGC1MZ::IDENTITY);
		nR = m_mz.GetIdentity(&cid, 0, NULL, 0);
	}
	

	cif.nSize = sizeof(CMGC1MZ::INFORMATION);
	nR = m_mz.GetInformation(&cif, 500);

	//cif.nFrequency = 38050.0;
	INT		nFigures = (INT)log10(cif.nFrequency);	// ?
	DOUBLE	nMultiplier = pow(10.00, (DOUBLE)(5 - nFigures));
	INT		nMulti = (INT)nMultiplier;
	
	if (nMulti != 0)
	{
		DOUBLE nF = (DOUBLE)cif.nFrequency * nMultiplier + 500.00;
		nFrequency = (INT)(nF / 1000.00) * 1000 / nMulti;
	}
	

	TCHAR szMessage[512];
	TCHAR szVendorName[CMGC1MZ::maxLengthForVenderName];
	TCHAR szModelName[CMGC1MZ::maxLengthForModelName];


	if(nR != CMGC1MZ::success)
	{
		_stprintf_s(szMessage, _T("Error = %d"), nR);
		AfxMessageBox(szMessage);
	}

	// ́̕AASCII
	_tcscpy_s(szVendorName, CA2T(cif.szVendorName));
	_tcscpy_s(szModelName, CA2T(cif.szModelName));
	
	_stprintf_s( szMessage, 
				_T("Vendor name : %s\nModel name : %s\nFrequency : %d MHz\nFamily : %d\n")\
				_T("Base family : %d\nExtended family : %d\nModel : %d\nBase model : %d\n")\
				_T("Extended model : %d\nStepping : %d\nCores : %d\nLogical cores : %d\n")\
				_T("Threads : %d\nFeature : 0x%04X"), 
				szVendorName, 
				szModelName, 
				nFrequency,
				cif.nFamily, 
				cif.nBaseFamily,
				cif.nExtendedFamily,
				cif.nModel, 
				cif.nBaseModel,
				cif.nExtendedModel,
				cif.nStepping,
				cif.nCores,
				cif.nLogicalCores,
				cif.nThreads,
				cif.nFeature	);

	m_labCPUID.SetWindowText(szMessage);

	m_chkMMX.SetCheck((cif.nFeature & CMGC1MZ::futureMMX) == CMGC1MZ::futureMMX);
	m_chkMMX_EXT.SetCheck((cif.nFeature & CMGC1MZ::futureMMXextended) == CMGC1MZ::futureMMXextended);
	m_chkSSE.SetCheck((cif.nFeature & CMGC1MZ::futureSSE) == CMGC1MZ::futureSSE);
	m_chkSSE2.SetCheck((cif.nFeature & CMGC1MZ::futureSSE2) == CMGC1MZ::futureSSE2);
	m_chkSSE3.SetCheck((cif.nFeature & CMGC1MZ::futureSSE3) == CMGC1MZ::futureSSE3);
	m_chkSSE4p1.SetCheck((cif.nFeature & CMGC1MZ::futureSSE4p1) == CMGC1MZ::futureSSE4p1);
	m_chkSSE4p2.SetCheck((cif.nFeature & CMGC1MZ::futureSSE4p2) == CMGC1MZ::futureSSE4p2);
	m_chkSSE4A.SetCheck((cif.nFeature & CMGC1MZ::futureSSE4A) == CMGC1MZ::futureSSE4A);
	m_chk3DNOW.SetCheck((cif.nFeature & CMGC1MZ::future3DNow) == CMGC1MZ::future3DNow);
	m_chk3DNOW_EXT.SetCheck((cif.nFeature & CMGC1MZ::future3DNowExtended) == CMGC1MZ::future3DNowExtended);
	m_chkAMD_V.SetCheck((cif.nFeature & CMGC1MZ::futureAMD_V) == CMGC1MZ::futureAMD_V);
	m_chkINTEL_VT.SetCheck((cif.nFeature & CMGC1MZ::futureIntelVT) == CMGC1MZ::futureIntelVT);
	m_chkX64.SetCheck((cif.nFeature & CMGC1MZ::futureX64) == CMGC1MZ::futureX64);


	//
	//// Windows Version
	//
	CMGC1MZ::WINDOWSVERSION wv;
	TCHAR szProductName[128];
	TCHAR szWindowsVersion[256];

	wv.dwWIndowsVersionSize = sizeof(CMGC1MZ::WINDOWSVERSION);
	m_mz.GetWindowsVersion(&wv);
	m_mz.QueryProduct(&wv, szProductName, 128);

	_stprintf_s(	szWindowsVersion,
					_T("%s (%d.%d.%d.%d)"), 
					szProductName,
					wv.dwMajorNumber,
					wv.dwMinorNumber,
					wv.dwRevisionNumber,
					wv.dwBuildNumber	);

	m_labWindowsVersion.SetWindowText(szWindowsVersion);


	//
	//// IsWOW64
	//
	INT		nN;
	TCHAR	szW64[32];
	LPCTSTR	lpstYesNo[2] = { _T("yes"), _T("no") };


	nN = (m_mz.IsWow64())? 0 : 1;

	_stprintf_s(szW64, _T("WOW64 : %s"), lpstYesNo[nN]);
	m_labWOW64.SetWindowText(szW64);

	
	//
	//// File Version
	//
	TCHAR	szVersion[256];
	DWORD	dwMajorNumber[2], dwMinorNumber[2], dwRevisionNumber[2], dwBildNumber[2];
#if _AMD64
	LPCTSTR lpszFile[2] = { _T("TestMZ64.exe"), _T("mgc1mz.dll") };
#else
	LPCTSTR lpszFile[2] = { _T("TestMZ32.exe"), _T("mgc1mz.dll") };
#endif

	for (INT nI = 0; nI < 2; nI++)
	{
		m_mz.GetFileVersion(	lpszFile[nI], 
								&dwMajorNumber[nI],
								&dwMinorNumber[nI], 
								&dwRevisionNumber[nI],
								&dwBildNumber[nI]	);
	}

	_stprintf_s(	szVersion,
					_T("%s Version : %d.%d.%d.%d  %s  Version : %d.%d.%d.%d"),
					lpszFile[0],
					dwMajorNumber[0],
					dwMinorNumber[0],
					dwRevisionNumber[0],
					dwBildNumber[0],
					lpszFile[1],
					dwMajorNumber[1],
					dwMinorNumber[1],
					dwRevisionNumber[1],
					dwBildNumber[1]	);

	m_labVersion.SetWindowText(szVersion);
	

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CTestMZDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CTestMZDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CTestMZDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

