#include "stdafx.h"
#include "m1mz.h"
// CM1MZ
//
//  mgc1mz.dll [hNXł
//	Ver1.1600a
//
CM1MZ::CM1MZ()
{
	LPCTSTR lpszMZ = _T("mgc1mz.dll");

	m_hMMZ = LoadLibrary(lpszMZ);

	if (m_hMMZ != NULL)
	{
		GetIdentity = (LPMMZGETIDENTITY)GetProcAddress(m_hMMZ, "mmzGetIdentity");
		GetInformation = (LPMMZGETINFORMATION)GetProcAddress(m_hMMZ, "mmzGetInformation");
		GetWindowsVersion = (LPMMZGETWINDOWSVERSION)GetProcAddress(m_hMMZ, "mmzGetWindowsVersion");
		IsWow64 = (LPMMZISWOW64)GetProcAddress(m_hMMZ, "mmzIsWow64");

		GetFileVersion = (LPMMZGETFILEVERSION)GetProcAddress(m_hMMZ, "mmzGetFileVersion");
		GetTemporaryFileName = (LPMMZGETTEMPORARYFILENAME)GetProcAddress(m_hMMZ, "mmzGetTemporaryFileName");
	}
}

CM1MZ::~CM1MZ()
{
	Unload();
}


// CMGC1MZ o֐
void CM1MZ::Unload()
{
	if (m_hMMZ)
	{
		BOOL bR = FreeLibrary(m_hMMZ);
		m_hMMZ = NULL;
	}
}

int CM1MZ::AreYouReady()
{
	return (m_hMMZ != NULL) ? yes : no;
}